## dxx-rebirth 20220929-src

=== SConstruct ===
#SConstruct
# vim: set fenc=utf-8 sw=4 ts=4 :
# e3faab0899bc86184fdd67568ccc4f237c5f6807

# needed imports
from collections import (defaultdict, Counter as collections_counter)
import base64
import binascii
import errno
import itertools
import subprocess
import sys
import os
import SCons.Util
import SCons.Script

# Disable injecting tools into default namespace
SCons.Defaults.DefaultEnvironment(tools = [])

def message(program,msg):
	print("%s: %s" % (program.program_message_prefix, msg))

def get_Werror_string(l):
	if l and '-Werror' in l:
		return '-W'
	return '-Werror='

class StaticSubprocess:
	# This class contains utility functions for calling subprocesses
	# that are expected to return the same output for every call.  The
	# output is cached after the first call, so that callers can request
	# the output again later without causing the program to be run again.
	#
	# Suitable programs are not required to depend solely on the
	# parameters, but are assumed to depend only on state that is
	# unlikely to change in the brief time that SConstruct runs.  For
	# example, a tool might be upgraded by the system administrator,
	# changing its version string.  However, we assume nobody upgrades
	# their tools in the middle of an SConstruct run.  Results are not
	# cached to persistent storage, so an upgrade performed after one
	# SConstruct run, but before the next, will not cause any
	# inconsistencies.
	from shlex import split as shlex_split
	class CachedCall:
		def __init__(self,out,err,returncode):
			self.out = out
			self.err = err
			self.returncode = returncode
	# @staticmethod delayed so that default arguments pick up the
	# undecorated form.
	def pcall(args,stderr=None,_call_cache={},_CachedCall=CachedCall):
		# Use repr since callers may construct the same argument
		# list independently.
		## >>> a = ['git', '--version']
		## >>> b = ['git', '--version']
		## >>> a is b
		## False
		## >>> id(a) == id(b)
		## False
		## >>> a == b
		## True
		## >>> repr(a) == repr(b)
		## True
		a = repr(args)
		c = _call_cache.get(a)
		if c is not None:
			return c
		p = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=stderr)
		(o, e) = p.communicate()
		_call_cache[a] = c = _CachedCall(o, e, p.wait())
		return c
	def qcall(args,stderr=None,_pcall=pcall,_shlex_split=shlex_split):
		return _pcall(_shlex_split(args),stderr)
	@staticmethod
	def get_version_head(cmd,_pcall=pcall,_shlex_split=shlex_split):
		# If cmd is bytes, then it is output from a program and should
		# not be reparsed.
		v = _pcall(([cmd] if isinstance(cmd, bytes) else _shlex_split(cmd)) + ['--version'], stderr=subprocess.PIPE)
		try:
			return v.__version_head
		except AttributeError:
			v.__version_head = r = (v.out or v.err).splitlines()[0].decode() if not v.returncode and (v.out or v.err) else None
			return r
	pcall = staticmethod(pcall)
	qcall = staticmethod(qcall)
	shlex_split = staticmethod(shlex_split)

class ToolchainInformation(StaticSubprocess):
	@staticmethod
	def get_tool_path(env,tool,_qcall=StaticSubprocess.qcall):
		# Include $LINKFLAGS since -fuse-ld=gold influences the path
		# printed for the linker.
		tool = env.subst('$CXX $CXXFLAGS $LINKFLAGS -print-prog-name=%s' % tool)
		return tool, _qcall(tool).out.strip()
	@staticmethod
	def show_partial_environ(env, user_settings, f, msgprefix, append_newline='\n'):
		f("{}: CHOST: {!r}{}".format(msgprefix, user_settings.CHOST, append_newline))
		for v in (
			'CXX',
			'CPPDEFINES',
			'CPPPATH',
			'CPPFLAGS',
			'CXXFLAGS',
			'LIBS',
			'LINKFLAGS',
		) + (
			(
				'RC',
				'RCFLAGS',
			) if user_settings.host_platform == 'win32' else (
				'FRAMEWORKPATH',
				'FRAMEWORKS',
			) if user_settings.host_platform == 'darwin' else (
			)
		):
			f("{}: {}: {!r}{}".format(msgprefix, v, env.get(v, None), append_newline))
		penv = env['ENV']
		for v in (
			'CCACHE_PREFIX',
			'DISTCC_HOSTS',
		):
			f("{}: ${}: {!r}{}".format(msgprefix, v, penv.get(v, None), append_newline))

class Git(StaticSubprocess):
	class ComputedExtraVersion:
		__slots__ = ('describe', 'status', 'diffstat_HEAD', 'revparse_HEAD')
		def __init__(self,describe,status,diffstat_HEAD,revparse_HEAD):
			self.describe = describe
			self.status = status
			self.diffstat_HEAD = diffstat_HEAD
			self.revparse_HEAD = revparse_HEAD
		def __repr__(self):
			return 'ComputedExtraVersion(%r,%r,%r,%r)' % (self.describe, self.status, self.diffstat_HEAD, self.revparse_HEAD)
	UnknownExtraVersion = (
		# If the string is alphanumeric, then `git archive` has rewritten the
		# string to be a commit ID.  Use that commit ID as a guessed default
		# when Git is not available to resolve a current commit ID.
		ComputedExtraVersion('0.60.0-beta2-2122-ge3faab0899bc', None, None, 'archive_e3faab0899bc86184fdd67568ccc4f237c5f6807') if 'e3faab0899bc86184fdd67568ccc4f237c5f6807'.isalnum() else
		# Otherwise, assume that this is a checked-in copy.
		ComputedExtraVersion(None, None, None, None)
		)
	# None when unset.  Instance of ComputedExtraVersion once cached.
	__computed_extra_version = None
	__path_git = None
	# `__pcall_missing_git`, `__pcall_found_git`, and `pcall` must have
	# compatible signatures.  In any given run, there will be at most
	# one call to `pcall`, which then patches itself out of the call
	# chain.  A run will call either __pcall_missing_git or
	# __pcall_found_git (depending on whether $GIT is blank), but never
	# both in the same run.
	@classmethod
	def __pcall_missing_git(cls,args,stderr=None,_missing_git=StaticSubprocess.CachedCall(None, None, 1)):
		return _missing_git
	@classmethod
	def __pcall_found_git(cls,args,stderr=None,_pcall=StaticSubprocess.pcall):
		return _pcall(cls.__path_git + args, stderr=stderr)
	@classmethod
	def pcall(cls,args,stderr=None):
		git = cls.__path_git
		if git is None:
			cls.__path_git = git = cls.shlex_split(os.environ.get('GIT', 'git'))
		cls.pcall = f = cls.__pcall_found_git if git else cls.__pcall_missing_git
		return f(args, stderr)
	def spcall(cls,args,stderr=None):
		g = cls.pcall(args, stderr)
		if g.returncode:
			return None
		return g.out
	@classmethod
	def compute_extra_version(cls,_spcall=spcall):
		c = cls.__computed_extra_version
		if c is None:
			v = cls.__compute_extra_version()
			cls.__computed_extra_version = c = cls.ComputedExtraVersion(
				v,
				_spcall(cls, ['status', '--short', '--branch']).decode(),
				_spcall(cls, ['diff', '--stat', 'HEAD']).decode(),
				_spcall(cls, ['rev-parse', 'HEAD']).rstrip().decode(),
			) if v is not None else cls.UnknownExtraVersion
		return c
	# Run `git describe --tags --abbrev=12`.
	# On failure, return None.
	# On success, return a string containing:
	#	first line of output of describe
	#	'*' if there are unstaged changes else ''
	#	'+' if there are staged changes else ''
	@classmethod
	def __compute_extra_version(cls):
		try:
			g = cls.pcall(['describe', '--tags', '--abbrev=12'], stderr=subprocess.PIPE)
		except OSError as e:
			if e.errno == errno.ENOENT:
				return None
			raise
		if g.returncode:
			return None
		_pcall = cls.pcall
		return (g.out.splitlines()[0] +	\
			(b'*' if _pcall(['diff', '--quiet']).returncode else b'') +	\
			(b'+' if _pcall(['diff', '--quiet', '--cached']).returncode else b'')
		).decode()

class _ConfigureTests:
	class Collector:
		class RecordedTest:
			__slots__ = ('desc', 'name', 'predicate')
			def __init__(self,name,desc,predicate=()):
				self.name = name
				self.desc = desc
				# predicate is a sequence of zero-or-more functions that
				# take a UserSettings object as the only argument.
				# A recorded test is only passed to the SConf logic if
				# at most zero predicates return a false-like value.
				#
				# Callers use this to exclude from execution tests which
				# make no sense in the current environment, such as a
				# Windows-specific test when building for a
				# Linux target.
				self.predicate = predicate
			def __repr__(self):
				return '_ConfigureTests.Collector.RecordedTest(%r, %r, %r)' % (self.name, self.desc, self.predicate)

		def __init__(self,record):
			self.record = record
		def __call__(self,f):
			desc = None
			doc = getattr(f, '__doc__', None)
			if doc is not None:
				doc = doc.rstrip().splitlines()
				if doc and doc[-1].startswith("help:"):
					desc = doc[-1][5:]
			self.record(self.RecordedTest(f.__name__, desc))
			return f

class ConfigureTests(_ConfigureTests):
	class Collector(_ConfigureTests.Collector):
		def __init__(self):
			# An unguarded collector maintains a list of tests, and adds
			# to the list as the decorator is called on individual
			# functions.
			self.tests = tests = []
			super().__init__(tests.append)

	class GuardedCollector(_ConfigureTests.Collector):
		def __init__(self,collector,guard):
			# A guarded collector delegates to the list maintained by
			# the input collector, instead of keeping a list of its own.
			super().__init__(collector.record)
			# `guard` is a single function, but the predicate handling
			# expects a sequence of functions, so store a single-element
			# tuple.
			self.__guard = guard,
			self.__RecordedTest = collector.RecordedTest
		def RecordedTest(self, name, desc, predicate=()):
			# Record a test with both the guard of this GuardedCollector
			# and any guards from the input collector objects, which may
			# in turn be instances of GuardedCollector with predicates
			# of their own.
			return self.__RecordedTest(name, desc, self.__guard + predicate)

	class CxxRequiredFeature:
		__slots__ = ('main', 'name', 'text')
		def __init__(self,name,text,main=''):
			self.name = name
			# Avoid generating consecutive underscores if the input
			# string has multiple adjacent unacceptable characters.
			f = '_{:x}'.format
			name = {'N' : 'test_' + ''.join([c if c.isalnum() else f(ord(c)) for c in name])}
			self.text = text % name
			self.main = ('{' + (main % name) + '}\n') if main else ''
	class Cxx11RequiredFeature(CxxRequiredFeature):
		std = 11
	class Cxx14RequiredFeature(CxxRequiredFeature):
		std = 14
	class Cxx17RequiredFeature(CxxRequiredFeature):
		std = 17
	class Cxx20RequiredFeature(CxxRequiredFeature):
		std = 20
	class CxxRequiredFeatures:
		__slots__ = ('features', 'main', 'text')
		def __init__(self,features):
			self.features = features
			s = '/* C++{} {} */\n{}'.format
			self.main = '\n'.join((s(f.std, f.name, f.main) for f in features if f.main))
			self.text = '\n'.join((s(f.std, f.name, f.text) for f in features if f.text))
	class PCHAction:
		def __init__(self,context):
			self._context = context
		def __call__(self,text,ext):
			# Ignore caller-supplied text, since _Test always includes a
			# definition of main().  Using the caller-supplied text
			# would provide one main() in the PCH and another in the
			# test which includes the PCH.
			env = self._context.env
			s = env['OBJSUFFIX']
			env['OBJSUFFIX'] = '.h.gch'
			result = self._context.TryCompile('''
/* Define this here.  Use it in the file which includes the PCH.  If the
 * compiler skips including the PCH, and does not fail for that reason
 * alone, then it will fail when the symbol is used in the later test,
 * since the only definition comes from the PCH.
 */
#define dxx_compiler_supports_pch
			''', ext)
			env['OBJSUFFIX'] = s
			return result
	class PreservedEnvironment:
		# One empty list for all the defaults.  The comprehension
		# creates copies, so it is safe for the default value to be
		# shared.
		def __init__(self,env,keyviews,_l=[]):
			self.flags = {k: env.get(k, _l)[:] for k in itertools.chain.from_iterable(keyviews)}
		def restore(self,env):
			env.Replace(**self.flags)
		def __getitem__(self,name):
			return self.flags.__getitem__(name)
	class ForceVerboseLog(PreservedEnvironment):
		def __init__(self,env):
			# Force verbose output to sconf.log
			self.flags = {}
			for k in (
				'CXXCOMSTR',
				'LINKCOMSTR',
			):
				try:
					# env is like a dict, but does not have .pop(), so
					# emulate it with a lookup + delete.
					self.flags[k] = env[k]

## dxx-rebirth 0.60~git20250524

=== debian/changelog ===
dxx-rebirth (0.60~git20250524-2) unstable; urgency=low

  * merge d1x-rebirth and d2x-rebirth into a single source package

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 11 Oct 2025 12:32:07 +0200

d1x-rebirth (0.60~git20250524-1) unstable; urgency=low

  * New GIT snapshot.
     - fix build with recent GCC/G++ (Closes: #1057551, #1057552)
     - look for data in /usr/share/games/descent1 (Closes: #781584)
     - fix static noise during audio playback in Descent 2 (Closes: #1069996)
  * Build against SDL2 (Closes: #1038183, #1038184)
  * d/control:
     + d1x-rebirth: add Depends on descent1-data | descent1-demo-data |
                                   game-data-packager (Closes: #776491)
     + d2x-rebirth: add Depends on descent2-data | descent2-demo-data |
                                   game-data-packager
     + set S-V to 4.7.2.
  * Install svg icons instead of old blurry xpm files.
  * Install AppStream metainfo.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 25 Aug 2025 09:39:10 +0200

d1x-rebirth (0.58.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Avoid defining objects twice; this allows building with GCC 10.
    Closes: #966187.

 -- Stephen Kitt <skitt@debian.org>  Sun, 02 Aug 2020 11:16:13 +0200

d1x-rebirth (0.58.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Allow building with Python 3. Closes: #947558.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Feb 2020 16:24:25 +0100

d1x-rebirth (0.58.1-1) unstable; urgency=low

  * New upstream release [July 2013].
  * Patchworks:
    - dropped "LDFLAGS.patch".
    + updated "debian.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 04 Aug 2013 06:24:09 +1000

d1x-rebirth (0.57.3-2) unstable; urgency=low

  * "XS-Autobuild: yes" + autobuild, thanks to Philipp Kern.
  * Corrected man page.
  * Removed non-existing package "d1x-rebirth-data-hires" from Recommends.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 04 Aug 2013 00:07:52 +1000

d1x-rebirth (0.57.3-1) unstable; urgency=low

  * Initial release (Closes: #576275).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 25 May 2013 06:26:12 +1000

=== debian/control ===
Source: dxx-rebirth
Section: non-free/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
               libglu1-mesa-dev,
               libphysfs-dev,
               libpng-dev,
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               scons
XS-Autobuild: yes
Homepage: http://www.dxx-rebirth.com
Vcs-Browser: https://salsa.debian.org/games-team/dxx-rebirth
Vcs-Git: https://salsa.debian.org/games-team/dxx-rebirth.git

Package: d1x-rebirth
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, descent1-data | descent1-demo-data | game-data-packager
Recommends: timidity, freepats
Description: port of the 1995 classic game Descent 1: First Strike
 DXX-Rebirth is a Source Port of the Descent & Descent ][ Engines and
 provides classical Gameplay combined with OpenGL graphics and effects,
 a bunch of improvements and new features.
 .
 This package provides the engine to play "Descent 1: First Strike"
 .
 Original game data is needed to play this game.

Package: d2x-rebirth
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, descent2-data | descent2-demo-data | game-data-packager
Recommends: timidity, freepats
Description: port of the 1996 classic game Descent 2: Counterstrike
 DXX-Rebirth is a Source Port of the Descent & Descent ][ Engines and
 provides classical Gameplay combined with OpenGL graphics and effects,
 a bunch of improvements and new features.
 .
 This package provides the engine to play "Descent 2: Counterstrike"
 .
 Original game data is needed to play this game.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

%:
	dh $@

override_dh_clean:
	scons --clean
	dh_clean .sconsign.dblite build/

override_dh_auto_build:
	CFLAGS="$(CFLAGS) $(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
        scons prefix=/usr verbosebuild=1 ipv6=1 sdl2=1 --debug=presub -j $(NUMJOBS)

execute_before_dh_install:
	install -m644 contrib/packaging/linux/descent.svg  build/d1x-rebirth.svg
	install -m644 contrib/packaging/linux/descent2.svg build/d2x-rebirth.svg
	install -m644 d1x-rebirth/d1x-rebirth.desktop build/io.github.dxx_rebirth.dxx_rebirth.d1x-rebirth.desktop
	install -m644 d2x-rebirth/d2x-rebirth.desktop build/io.github.dxx_rebirth.dxx_rebirth.d2x-rebirth.desktop

override_dh_installchangelogs:
	dh_installchangelogs -pd1x-rebirth d1x-rebirth/RELEASE-NOTES.txt
	dh_installchangelogs -pd2x-rebirth d2x-rebirth/RELEASE-NOTES.txt
